<?php
/*
 #########################################################################
 #                       xt:Commerce VEYTON 4.0 Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2007-2011 xt:Commerce International Ltd. All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce VEYTON 4.0 Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # http://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @version $Id: xt_etracker.php 4547 2011-05-02 09:13:47Z dev_tunxa $
 # @copyright xt:Commerce International Ltd., www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce International Ltd., Kafkasou 9, Aglantzia, CY-2112 Nicosia
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */
defined('_VALID_CALL') or die('Direct Access is not allowed.');

class xt_etracker{
	
	private $etracker_code_version = '3.0';
	private $etracker_taghost = 'code.etracker.com';
	private $etracker_cnthost = 'www.etracker.de';
	private $tval;
	private $basket;
	private $tonr;
	private $order;
	
	function _getCode($page_section) {
		
		if(XT_ETRACKER_ACTIVATED == 'false')
		return '';

		$cryptId = XT_ETRACKER_SECURECODE;
		
		if(!preg_match("/^[0-9a-zA-Z]+$/", $cryptId))
		return '';
		
		// parameter check
		$ssl			= XT_ETRACKER_SSL=='true' ? 1 : 0;
		$pagename		= rawurlencode( $this->_getPagename($page_section));
		$areas			= rawurlencode( $this->_getArea($page_section) );
		
		if(XT_ETRACKER_AKTIVATE_CART == 'true'){
			$ilevel			= 1;
			$targets		= rawurlencode( $this->_getTarget($page_section) );
			$tval 			= str_replace(',', '.', $this->tval);
			$tval 			= is_numeric($this->tval) ? $this->tval : 0;
			$tsale			= $this->_getTsales($page_section);
			$tonr 			= str_replace('"', '', $this->tonr);
			$customer		= $this->isNewcustomer() ? 1 : 0;
			
			$basket			= rawurlencode( $this->basket );
			
		}else{
			$ilevel			= 0;
			$targets		= '';
			$tval 			= 0;
			$tsale			= 0;
			$tonr 			= '';
			$customer		= 0;
			$basket			= '';
		}
		
		if(isset($_GET['keywords']))
			$tsub		= $_GET['keywords'];
		else 
			$tsub		= '';
		
		
		if($pagename == 'SEARCH')
			$lpage 		= XT_ETRACKER_SEARCHRESULT_LPAGE;
		else{
			$lpage		= '';
			$tsub		= '';
		}
		
		// trigger
		$trigger		= preg_replace("/\s{1,}/", '', $trigger); // remove all \s*
		$trigger		= preg_match("/^[0-9,]+$/", $trigger) ? $trigger : ''; // comma separated list of integers
		
		
		$se				= XT_ETRACKER_SEARCHEENGINE;
		$url			= str_replace('"', '', $this->getURL());
		$tag			= str_replace('"', '', $tag);
		$organisation 	= "";
		$demographic  	= "";
		$noScript		= XT_ETRACKER_NOSCRIPT == 'true' ? true : false;
		
		$code  = "<!-- Copyright (c) 2000-".date("Y")." etracker GmbH. All rights reserved. -->\n";
		$code .= "<!-- This material may not be reproduced, displayed, modified or distributed -->\n";
		$code .= "<!-- without the express prior written permission of the copyright holder. -->\n\n";
		$code .= "<!-- BEGIN etracker Tracklet ".$this->etracker_code_version." -->\n";
		$code .= "<script type=\"text/javascript\">document.write(String.fromCharCode(60)+\"script type=\\\"text/javascript\\\" src=\\\"http\"+(\"https:\"==document.location.protocol?\"s\":\"\")+\"://".$this->etracker_taghost."/t.js?et=".$cryptId."\\\">\"+String.fromCharCode(60)+\"/script>\");</script>\n";
		//$code .= "<p style=\"display:none;\" id=\"et_count\"></p>";
		$code .= $this->getParameters( $showAll, $easy, $pagename, $areas, $ilevel,
		$targets, $tval, $tsale, $tonr, $lpage, $tsub, $trigger,
		$customer, $basket, $free, $se, $url);
		
		$code .= "<script type=\"text/javascript\">_etc();</script>\n";
		$code .= "<noscript><p><a href=\"http://www.etracker.com\"><img style=\"border:0px;\" alt=\"\" src=\"https://www.etracker.com/nscnt.php?et=".$cryptId."\" /></a></p></noscript>\n";
		
		if($noScript)
		$code .= $this->getNoScriptTag( $cryptId, $easy, $ssl, $pagename, $areas, $ilevel,
		$targets, $tval, $tsale, $tonr, $lpage, $tsub, $trigger,
		$customer, $basket, $free, $se, $url, $tag);
		
		$code .= "<!-- etracker CODE END -->\n\n";
		
		if(XT_ETRACKER_CC_ECOMMERCEAPI == 'true'){
			$apiCode = "<!-- xtetracker API Calls -->\n";
			$apiCode .= $this->_getApiCode($page_section);
			$apiCode .= "<!-- xtetracker API Calls end -->\n\n";
		}else{
			$apiCode = "";
		}
		
		$code .= $apiCode;
		
		return $code;
	}
	
	/**
	 * 
	 */
	function _getTsales($page_section){
		global $page;
		$lead_payments = explode(',', XT_ETRACKER_LEAD_PAYMENTS);
		$lps = array();
		foreach ($lead_payments as $key=>$value){
			if(trim($value)!='')
				$lps[] = trim($value);
		}
		$lps[] = '';
		switch($page_section)
		{
			case 'checkout':
				if($page->page_action != '')
					switch($page->page_action){
						case 'success': if(in_array($this->order->order_data['payment_code'], $lead_payments)) return 0; else return 1;
											
						break; 
				}
			break;
		}
		return 0;
	}
	
	/**
	* get Target
	*@param $page_section string
	*@return string
	*
	**/
	
	function _getTarget($page_section){
		global $page;
		
		switch($page_section)
		{
			case 'checkout':
				if($page->page_action != '')
					switch($page->page_action){
						case 'payment':
							return 'cart/customer/shipping/'.$page->page_action;
							break;
						case 'success':
							return 'cart/customer/shipping/payment/confirmation/'.$page->page_action;
							break;
						case 'confirmation':
							return 'cart/customer/shipping/payment/'.$page->page_action;
						default:
							return 'cart/customer/'.$page->page_action;
					}
					
				else return 'cart';		
				break;
			case 'cart':
				if($page->page_action != '')
					return 'cart/customer/'.$page->page_action;
				else return 'cart';
				break;
			case 'customer':
				if($page->page_action != '')
					return 'cart/customer/'.$page->page_action;
				else
					return 'cart/customer/';
				break;
		}
	}
	
	/**
	* get Area
	*@param $page_section string
	*@return string
	*
	**/
	
	function _getArea($page_section){
		global $language, $p_info, $xtLink, $db, $shop_content_data, $manufacturer, $current_manufacturer_id, $category, $current_category_id;
		
		switch($page_section)
		{
			case 'product':
				$current_manufacturer_id = $p_info->data['manufacturers_id'];
				$man = array('manufacturers_id' => $current_manufacturer_id);
				$man_data = $manufacturer->buildData($man);
				return str_replace($language->content_language,$language->content_language.'/products/',$man_data['url_text']);
				break;
			case 'content':
				return str_replace($language->content_language,$language->content_language.'/contents/',$shop_content_data['url_text']);
				break;
			case 'manufacturers':
				$man = array('manufacturers_id' => $current_manufacturer_id);
				$man_data = $manufacturer->buildData($man);
				return str_replace($language->content_language,$language->content_language.'/manufacturers/',$man_data['url_text']);
				break;
			case 'categorie':
				return str_replace($language->content_language,$language->content_language.'/categories/',$category->current_category_data['url_text']);
				break;
			case 'customer':
				return 'customer/'.$page->page_action;
				break;
			case 'cart':
				return 'cart/'.$page->page_action;
				break;
			case 'checkout':
				return 'checkout/'.$page->page_action;
				break;
			case 'search':
				return 'search';
				break;
			default:
				return '';
			break;
		}
	}
	
	function isNewcustomer(){
		if($SESSION['customer']->customers_id > 0){
			$date_added = strtotime($SESSION['customer']->customer_info['date_added']);
			$yesterday = date('Y-m-d H:i:s', mktime(0, 0, 0, date("m") , date("d") - 1, date("Y")));
			if($date_added> $yesterday)
				return true;
			else
				return false;
		}
		else{
			return false;
		}
	}
	
	function getTval(){

		$this->tval  = $this->order->order_total['total']['plain'];
	}
	
	function getTonr(){
		if(!isset($_SESSION['success_order_id'])){
			$this->tonr = 0;
			return false;
		}else{
			$this->tonr = $_SESSION['success_order_id'];
			return true;
		}
	}
	
	function getBasket(){
		
		$basket_content = $this->order->order_products;
		$this->basket = '';
		foreach($basket_content as $key=>$value){
			$this->basket .= $value['products_id'].','.$value['products_name'].','.$value['products_model'].','.(int)$value['products_quantity'].','.$value['products_price']['plain'].';';
		}	
		$this->basket = substr($this->basket, 0, -1) ;
		return true;
	}
	
	function getURL(){
	
		return urlencode($_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']);
	}
	
	/**
	* get API Javascript Code
	* @param $page_section string
	* @return string
	*
	* */
	public function _getApiCode($page_section)
	{
		global $p_info, $tpl_product_listing, $search_result;
		
		switch($page_section)
		{
			case 'product':
				$ret = $this->_getApiProductTracklet();
				break;
			case 'categorie':
			case 'manufacturers':
			case 'search':
				if(is_array($tpl_product_listing)){
					$ret = $this->_getApiProductListingTracklet($tpl_product_listing);
				}elseif(is_array($GLOBALS['search_result']) && is_array($search_result['product_listing'])){
					$ret = $this->_getApiProductListingTracklet($search_result['product_listing']);
				}
				break;
			case 'cart':
				$ret = $this->_getApiCartTracklet();
				break;
			case 'checkout':
				$ret = $this->_getApiCheckoutTracklet();
				break;
			/*
			case 'content':
				return $this->_getContentPagename();
				break;
			case 'manufacturers':
				return $this->_getManufacturersPagename();
				break;
			case 'customer':
				return $this->_getCustomerPagename();
				break;
			case 'cart':
				return $this->_getCartPagename();
				break;
			case 'checkout':
				return $this->_getCheckoutPagename();
				break;
			case 'search':
				return $this->_getSearchPagename();
				break;
			*/
			default:
				$ret = false;
				break;
		}
		return $ret ? "<script type=\"text/javascript\">\n".$ret."\n</script>\n" : "";
	}

	public function _getApiProductListingTracklet($products = null)
	{
		global $currency;
		/* @var $currency currency */
		#$this#
		$jsProducts = "{";
		$first = true;
		foreach($products as $prod)
		{
			$jsProd = "";
			if(!$first){
				$jsProd .= ", ";
			}
			$first = false;
			$id		 = $prod['products_id'];
			$jsProd	 .= "'$id' : ";
			$jsProd .= $this->_getApiProductCode($id, $prod['products_name'], "[]", $prod['products_price']['plain'], $currency->code);
			
			$jsProducts .= $jsProd;
		}
		$jsProducts .= "}";

		$code = <<<EOD
(function(){
    var products = $jsProducts;


    $('input[value="add_product"][name="action"]').each(
    function(index,value){
        var form = value.form;
        var prodid = $(form.product).val();
        
        if(prodid in products){
            var product = products[prodid];
			if(typeof product == "object"){
                $(form).submit(
                    function(){
						var quantity = $(this.qty).val();
						if( !isNaN(parseInt(quantity)) && isFinite(quantity) && quantity != 0 ){
							if(quantity < 0){
								quantity = 1
							}
							etCommerce.sendEvent('insertToBasket',product,parseInt(quantity));
						}
                    }
                );
            }
        }
    });
})();
EOD;
//*/
		return $code;
	}

	public function _getApiCartTracklet($products = null)
	{
		global $currency;
		
		if (is_object($_SESSION['cart']) && count($_SESSION['cart']->show_content) > 0){
			$products = $_SESSION['cart']->show_content;
			
			$jsProducts = "{";
			$first = true;
			foreach($products as $id=>$prod)
			{
				if(!$first){
					$jsProducts .= ", ";
				}
				$first = false;
				#$id		 = $prod['products_id'];
				$quantity = $prod['products_quantity'];
				$jsProd	 = "'$id' : {";
				$jsProd .= "'product' : ".$this->_getApiProductCode($prod['products_id'], $prod['products_name'], "[]", $prod['products_price']['plain'], $currency->code);
				$jsProd .= ", 'quantity' : ".(is_numeric($quantity) ? $quantity : 0);
				$jsProd .= " }";
				$jsProducts .= $jsProd;
			}
			$jsProducts .= "}";
			
			$code = <<<EOD
(function(){var a=$jsProducts;$('input[value="update_product"][name="action"]').each(function(b,c){var d=c.form;$(d).submit(function(){var b=d["products_key[]"];if("length"in b){for(var c=0;c<b.length;c++){if(c in b){var e=$(b[c]).val();if(e in a){if($(d["cart_delete[]"][c]).is(":checked")){var f=0}else{var f=parseFloat($(d["qty[]"][c]).val());if(isNaN(f)||!isFinite(f)){f=0}else if(f<0){f=1}}var g=f-a[e].quantity;if(g>0){etCommerce.sendEvent("insertToBasket",a[e].product,g)}else if(g<0){etCommerce.sendEvent("removeFromBasket",a[e].product,-g)}}}}}else{var e=$(b).val();if(e in a){if($(d["cart_delete[]"]).is(":checked")){var f=0}else{var f=parseFloat($(d["qty[]"]).val());if(isNaN(f)||!isFinite(f)){f=0}else if(f<0){f=1}}var g=f-a[e].quantity;if(g>0){etCommerce.sendEvent("insertToBasket",a[e].product,g)}else if(g<0){etCommerce.sendEvent("removeFromBasket",a[e].product,-g)}}}})})})()
EOD;
/*
(function(){
	var products = $jsProducts;

	$('input[value="update_product"][name="action"]').each(
		function(index,value){
			var form = value.form;
			$(form).submit(
				function(){
					var prodkeys = form['products_key[]'];
					if("length" in prodkeys){
						for( var i = 0; i < prodkeys.length; i++){
							if(i in prodkeys){
								var key = $(prodkeys[i]).val();
								if(key in products){
									if($(form['cart_delete[]'][i]).is(":checked")){
										var newquant = 0;
									}else{
										var newquant = parseFloat($(form['qty[]'][i]).val());
										if(isNaN(newquant) || !isFinite(newquant)){
											newquant = 0;
										}else if(newquant < 0){
											newquant = 1;
										}
									}
									var diff = newquant - products[key].quantity
									if(diff > 0){
										etCommerce.sendEvent('insertToBasket',products[key].product ,diff);
									}else if(diff < 0){
										etCommerce.sendEvent('removeFromBasket',products[key].product ,-diff);
									}
								}
							}
						}
					}else{
						var key = $(prodkeys).val();
						if(key in products){
							if($(form['cart_delete[]']).is(":checked")){
								var newquant = 0;
							}else{
								var newquant = parseFloat($(form['qty[]']).val());
								//stellt das Verhalten von xtCommerce nach. 
								if(isNaN(newquant) || !isFinite(newquant)){ // keine zahl entfernt das Produkt
									newquant = 0;
								}else if(newquant < 0){ //negative Zahlen ändern die Anzahl auf 1
									newquant = 1;
								}
							}
							var diff = newquant - products[key].quantity
							if(diff > 0){
								etCommerce.sendEvent('insertToBasket',products[key].product ,diff);
							}else if(diff < 0){
								etCommerce.sendEvent('removeFromBasket',products[key].product ,-diff);
							}
						}
					}
					
				});
		});
})();
EOD;
//*/
			
		}
		
		return $code;
	}

	
	public function _getApiCheckoutTracklet()
	{
		global $page,$currency,$customers_status,$success_order;
		/* @var $currency currency */
		/* @var $customers_status customers_status */
		/* @var $success_order order */
		$customer = $_SESSION['customer'];
		/* @var $customer customer */
		
		
		if($page->page_action=='success' && $this->order ){
			if (is_object($_SESSION['cart']) ){//&& count($_SESSION['cart']->show_content) > 0){
				$products = $success_order->order_products;
				

				$basket = new stdClass();
				//da der Warenkorb scheinbar nur in der session existiert, irgendwie doof
				$basket->id = $customer->customers_id;
				$basket->products = array();
				
				foreach($products as $prod)
				{
					$quantity = $prod['products_quantity'];
					$jsProd = new stdClass();
					$jsProd->product = json_decode($this->_getApiProductCode($prod['products_id'], $prod['products_name'], array(), $prod['products_price']['plain'], $currency->code));
					$jsProd->quantity = (is_numeric($quantity) ? $quantity : 0);
					
					$basket->products[] = $jsProd;
				}
				

				
				$data = new stdClass;
				$data->orderNumber = $this->tonr;
				$data->status = $this->_getTsales('checkout') ? "sale" : "lead";
				$data->orderPrice = (string) $this->tval;
				$data->currency = $currency->code;
				$data->basket = $basket;
				
				$data->customerId = $customer->customers_id;
				$data->customerGroup = $customers_status->getGroupName($_SESSION['customer']->customers_status);
				$shipadr = $customer->customer_shipping_address;
				
				
				#$data->customerAdress = $shipadr[''];
				#$data->invoiceAdress = "";
				$data->paymentMethod = $this->order->order_data['payment_code'];
				//$data->deliveryConditions = "";
				//$data->paymentConditions = "";
				//$data->shipType = "";
				//$data->shipCosts = "";
				//$data->couponCodes = "";
				//$data->giftPackage = array();
				//$data->differenceData = false;
				
				$code = "(function(){\n";
				$code .= "var order = ";
				$code .= json_encode($data);
				$code .=";\n";
				//$code .= "alert('i am here');";
				$code .= "\netCommerce.sendEvent('order',order);\n";
				$code .= "})()";
				
			}
		}
		
		return $code;
	}
	
	
	/**
	* get Pagename for Product
	*
	* @return string
	*
	* */
	public function _getApiProductTracklet() {
		global $p_info,$brotkrumen,$currency,$manufacturer;
		/* @var $brotkrumen brotkrumen */
		/* @var $p_info product */
		/* @var $currency currency */
		/* @var $manufacturer manufacturer */
		
		//key of the product id in $p_info->data
		$masterKey = $p_info->master_id;
		//key of the display name in $p_info->data
		$displayKey = $p_info->_display_key;
		
		//key of the manufacturer display name in $manufacturer->data
		$manufDispKey = $manufacturer->_display_key;
		
		$id = $p_info->data[$masterKey];
		$name		 = $p_info->data[$displayKey];
		
		$categorys = array();
		if(is_array($brotkrumen->krumen))
		{
			foreach($brotkrumen->krumen as $value)
			{
				$categorys[] = $value['name'];
				if(count($categorys) >= 4){
					break;
				}
			}
			if(count($categorys) == count($brotkrumen->krumen)){
				array_pop($categorys);
			}
		}
		#$cat	 = "['".  implode("','", $categorys)."']";
		$cat	 = $categorys;
		$price = $p_info->data['products_price']['plain'];
		$variants = new stdClass();
		$pro_name = $manufacturer->data[$manufDispKey] ? $manufacturer->data[$manufDispKey] : null;
		$ean = $p_info->data['products_ean'] ? $p_info->data['products_ean'] : null;
		
		
		$code = "(function(){";
		$code .= "var product = ".$this->_getApiProductCode($id, $name, $cat, $price, $currency->code, $variants, $pro_name, $ean).";";
		
		$code .= "\netCommerce.sendEvent('viewProduct',product);\n";
		
		$code .= <<<EOD

$('input[value="add_product"][name="action"]').each(
	function(index,value){
		var form = value.form;
		var prodid = $(form.product).val();
		if(prodid == product.id){
			$(form).submit(
				function(){
					var quantity = $(this.qty).val();
					//xtcommerce ignores invalid numbers and 0, but converts negative numbers to '1'
					if( !isNaN(parseInt(quantity)) && isFinite(quantity) && quantity != 0 ){
						if(quantity < 0){
							quantity = 1
						}
						etCommerce.sendEvent('insertToBasket',product,parseInt(quantity));
						
					}
				}
				);
		}
	});
EOD;
		
		$code .= "})();";
		return $code;
	}
	
	/**
	 * 
	 * @param string Product unique Identifier
	 * @param string product name
	 * @param array product Categorys (strings)
	 * @param float product Price
	 * @param string 3-digit Currency Code
	 * @param array assosiacitve (key => value) Array of Product Types
	 * @param string Product Manufacturer
	 * @param string european article number
	 * @return string
	 */
	public function _getApiProductCode(
			$id, 
			$name, 
			$category, 
			$price, 
			$currency, 
			$variants = null, 
			$producer = null, 
			$ean = null
	)
	{
		$obj = new stdClass();
		$obj->id = $id;
		$obj->name = $name;
		$obj->category = $category;
		$obj->price = number_format($price, 2, ".", "");
		$obj->currency = $currency;
		$obj->variants = $variants ?: new stdClass();
		if($producer)
		{
			$obj->pro_name = $producer;
		}
		if($ean)
		{
			$obj->ean = $ean;
		}
		
		return json_encode($obj);
	}

	/**
	* get Pagename
	* @param $page_section string
	* @return string
	*
	* */
	public function _getPagename($page_section)
	{
		switch($page_section)
		{
			case 'product':
				return $this->_getProductPagename();
				break;
			case 'content':
				return $this->_getContentPagename();
				break;
			case 'manufacturers':
				return $this->_getManufacturersPagename();
				break;
			case 'categorie':
				return $this->_getCategoriePagename();
				break;
			case 'customer':
				return $this->_getCustomerPagename();
				break;
			case 'cart':
				return $this->_getCartPagename();
				break;
			case 'checkout':
				return $this->_getCheckoutPagename();
				break;
			case 'search':
				return $this->_getSearchPagename();
				break;
			default:
				return '__INDEX__';
			break;
		}
	}
	
	
	/**
	* get Pagename for Customer
	*
	* @return string
	*
	* */
	public function _getCustomerPagename() {
		global $page;
		if($page->page_action != '')
			return 'customer__'.$page->page_action;
		else
		return 'customer';
	}
	
	/**
	* get Pagename for Cart
	*
	* @return string
	*
	* */
	public function _getCartPagename() {
		global $page;
		if($page->page_action != '')
		return 'cart__'.$page->page_action;
		else
		return 'cart';
	}
	
	/**
	* get Pagename for Checkout
	*
	* @return string
	*
	* */
	public function _getCheckoutPagename() {
		global $page;
		if($page->page_action != ''){
			if($page->page_action=='success'){
				$this->getTonr();
				$this->order = new order($this->tonr,$_SESSION['customer']->customers_id);
				$this->getBasket();
				$this->getTval();
			}
			
			return 'checkout__'.$page->page_action;
		}
		else
			return 'checkout';
	}
	
	public function _getSearchPagename(){
		return 'search';	
	}
	
	/**
	* get Pagename for Product
	*
	* @return string
	*
	* */
	public function _getProductPagename() {
		global $p_info,$xtLink,$db;
	
		// check if product is slave product and either master setting is true or product setting is true
		if ($p_info->data['products_master_model']!='') {
			$sql = "SELECT products_id,products_canonical_master FROM ".TABLE_PRODUCTS." WHERE products_model='".$p_info->data['products_master_model']."' LIMIT 0,1";
			$rs = $db->Execute($sql);
			if ($rs->RecordCount()!=1) return false;
			if (XT_CANONICAL_APPLY_TO_ALL_SLAVES=='true' or $rs->fields['products_canonical_master']=='1') {
				$can_product = new product($rs->fields['products_id']);
				return $can_product->data['url_text'];
			}
		}
	
		return 'product__'.str_replace('/', '__', $p_info->data['url_text']);
	}
	
	/**
	* get Pagename for Content
	*
	* @return string
	*
	* */
	public function _getContentPagename() {
		global $shop_content_data,$xtLink;

		return 'content__'.str_replace('/', '__', $shop_content_data['url_text']);
	}
	
	/**
	* get Pagename for Manufacturer
	*
	* @return string
	*
	* */
	public function _getManufacturersPagename() {
		global $manufacturer,$current_manufacturer_id,$xtLink;
		$man = array('manufacturers_id' => $current_manufacturer_id);
		$man_data = $manufacturer->buildData($man);
		return 'manufactures__'.str_replace('/', '__', $man_data['url_text']);
	}
	
	/**
	* get Pagename for Categogie
	*
	* @return string
	*
	* */
	public function _getCategoriePagename() {
		global $category,$current_category_id,$xtLink;
		return 'category__'.str_replace('/', '__', $category->current_category_data['url_text']);
	}
	
	/***********************************************************
	* Note: private function below
	* use only main function 'getCode()'
	/***********************************************************/
	
	/**
	 * \brief Get parameters
	 * gives back the parameter code block
	 *
	 * \param	boolean \a $easy [false]
	 * \param	boolean \a $ssl [false]
	 * \param	string 	\a $pagename ['']
	 * \param	string 	\a $areas ['']
	 * \param	integer \a $ilevel [0]
	 * \param	string 	\a $targets ['']
	 * \param	float 	\a $tval ['']
	 * \param	integer \a $tsale [0]
	 * \param	string 	\a $tonr ['']
	 * \param	integer \a $lpage [0]
	 * \param	integer \a $lpage [0]
	 * \param	string 	\a $trigger ['']
	 * \param	integer \a $customer [0]
	 * \param	string 	\a $basket ['']
	 * \param	boolean \a $free [false]
	 * \param	integer \a $se [0]
	 * \param	string 	\a $url ['']
	 * \return	string
	 * \private
	 */
	function getParameters(	$showAll 		= false,
	$easy 			= 0,
	$pagename 		= '',
	$areas 			= '',
	$ilevel 		= 0,
	$targets 		= '',
	$tval 			= '',
	$tsale 			= 0,
	$tonr 			= 0,
	$lpage 			= 0,
	$tsub			= 0,
	$trigger 		= 0,
	$customer		= 0,
	$basket 		= '',
	$free 			= false,
	$se 			= 0,
	$url			= '',
	$tag			= '',
	$organisation 	= '',
	$demographic  	= ''
	)
	{
		$code = '';
	
		if($easy)
		$code .= "var et_easy         = $easy;\n";
		if($pagename || $showAll)
		$code .= "var et_pagename     = \"$pagename\";\n";
		if($areas || $showAll)
		$code .= "var et_areas        = \"$areas\";\n";
		if($ilevel || $showAll)
		$code .= "var et_ilevel       = ".$ilevel.";\n";
		if($url || $showAll)
		$code .= "var et_url          = \"$url\";\n";
		if($tag || $showAll)
		$code .= "var et_tag          = \"$tag\";\n";
		if(!empty($organisation))
		$code .= "var et_organisation = \"$organisation\";\n";
		if(!empty($demographic))
		$code .= "var et_demographic  = \"$demographic\";\n";
		if($targets || $showAll)
		$code .= "var et_target       = \"$targets\";\n";
		if($tval || $showAll)
		$code .= "var et_tval         = \"$tval\";\n";
		if($tonr || $showAll)
		$code .= "var et_tonr         = \"$tonr\";\n";
		if($tsale || $showAll)
		$code .= "var et_tsale        = $tsale;\n";
		if($customer || $showAll)
		$code .= "var et_cust         = $customer;\n";
		if($basket || $showAll)
		$code .= "var et_basket       = \"$basket\";\n";
		if($lpage || $showAll)
		$code .= "var et_lpage        = \"$lpage\";\n";
		if($tsub || $showAll)
		$code .= "var et_sub          = \"$tsub\";\n";
		if($trigger || $showAll)
		$code .= "var et_trig         = \"$trigger\";\n";
		if($se || $showAll)
		$code .= "var et_se           = \"$se\";\n";
	
		$ret = '';
		if($code)
		{
			$ret .= "\n<!-- etracker PARAMETER ".$this->etracker_code_version." -->\n";
			$ret .= "<script type=\"text/javascript\">\n";
			$ret .= $code;
			//$ret .= "etCommerce.debugMode = true;\n";
			$ret .= "</script>\n";
			$ret .= "<!-- etracker PARAMETER END -->\n\n";
		}
		return $ret;
	}
	
	/**
	* \brief Get noscript block
	* gives back the noscript image tag
	*
	* \param	string 	\a $cryptId
	* \param	boolean \a $easy [false]
	* \param	boolean \a $ssl [false]
	* \param	string 	\a $pagename ['']
	* \param	string 	\a $areas ['']
	* \param	integer \a $ilevel [0]
	* \param	string 	\a $targets ['']
	* \param	float 	\a $tval ['']
	* \param	integer \a $tsale [0]
	* \param	string 	\a $tonr ['']
	* \param	integer \a $lpage [0]
	* \param	integer \a $tsub [0]
	* \param	string 	\a $trigger ['']
	* \param	integer \a $customer [0]
	* \param	string 	\a $basket ['']
	* \param	boolean \a $free [false]
	* \param	integer \a $se [0]
	* \param	string 	\a $url ['']
	* \return	string
	* \private
	*/
	function getNoScriptTag($cryptId,
	$easy 			= false,
	$ssl 			= false,
	$pagename 		= '',
	$areas 			= '',
	$ilevel 		= 0,
	$targets 		= '',
	$tval 			= '',
	$tsale 			= 0,
	$tonr 			= 0,
	$lpage 			= 0,
	$tsub 			= 0,
	$trigger 		= 0,
	$customer		= 0,
	$basket 		= '',
	$free 			= false,
	$se 			= 0,
	$url			= '',
	$tag			= '',
	$organisation 	= '',
	$demographic  	= '')
	{
		$script 		= $free ? 'fcnt' : 'cnt';
	
		$code .= "<!-- etracker CODE NOSCRIPT ".$this->etracker_code_version." -->\n";
		$code .= "<noscript>\n";
		$code .= "<p><a href='http://".$this->etracker_cnthost."/app?et=$cryptId'>\n";
		$code .= "<img style='border:0px;' alt='' src='";
		if($ssl==1) $code .= "https"; else $code .= "http";
		$code .= "://".$this->etracker_cnthost."/$script.php?\n";
		$code .= "et=$cryptId&amp;v=".$this->etracker_code_version."&amp;java=n&amp;et_easy=$easy\n";
		$code .= "&amp;et_pagename=$pagename\n";
		$code .= "&amp;et_areas=$areas&amp;et_ilevel=$ilevel&amp;et_target=$targets,$tval,$tonr,$tsale\n";
		$code .= "&amp;et_lpage=$lpage&amp;et_tsub=$tsub&amp;et_trig=$trigger&amp;et_se=$se&amp;et_cust=$customer\n";
		$code .= "&amp;et_basket=$basket&amp;et_url=&amp;et_tag=".$tag."' /></a></p>\n";
		$code .= "</noscript>\n";
		$code .= "<!-- etracker CODE NOSCRIPT END-->\n\n";
		return $code;
	}
}